【多维 DP】力扣2400. 恰好移动 k 步到达某一位置的方法数目

给你两个 正 整数 startPos 和 endPos 。最初,你站在 无限 数轴上位置 startPos 处。在一步移动中,你可以向左或者向右移动一个位置。

给你一个正整数 k ,返回从 startPos 出发、恰好 移动 k 步并到达 endPos 的 不同 方法数目。由于答案可能会很大,返回对 109 + 7 取余 的结果。

如果所执行移动的顺序不完全相同,则认为两种方法不同。

注意:数轴包含负整数。

示例 1:

输入:startPos = 1, endPos = 2, k = 3

输出:3

解释:存在 3 种从 1 到 2 且恰好移动 3 步的方法:

  • 1 -> 2 -> 3 -> 2.
  • 1 -> 2 -> 1 -> 2.
  • 1 -> 0 -> 1 -> 2.
    可以证明不存在其他方法,所以返回 3 。

示例 2:

输入:startPos = 2, endPos = 5, k = 10

输出:0

解释:不存在从 2 到 5 且恰好移动 10 步的方法。

提示:

1 <= startPos, endPos, k <= 1000

动态规划

cpp 复制代码
class Solution {
public:
    int numberOfWays(int startPos, int endPos, int k) {
        int MOD = 1e9+7;
        int offset = 1000;
        int maxRange = startPos + k;
        int minRange = startPos - k;
        vector<vector<int>> dp(3 * offset + 2, vector<int>(k+1));
        dp[startPos + offset][0] = 1;

        for(int j = 1; j <= k; j++){
            for(int i = minRange + offset; i <= maxRange + offset; i++){
                dp[i][j] = (dp[i-1][j-1] + dp[i+1][j-1]) % MOD;
            }
        }
        return dp[endPos + offset][k];
    }
};

这道题我们定义了一个偏移量offset,offset用于处理负轴上的数据,使他们在dp上的索引是正数。这道题我们需要注意的是如何定义dp的范围,由于startPos和k都在1000以内,那么负轴上最低的是startPos-k,因为startPos是正整数,所以负轴上最低是-999,正轴上最高是startPos+k,也就是2000,那么他们的范围就是3000,由于方便处理动态规划过程中的边界问题,令dp的行大小为3000+2。

我们定义一个二维数组dpij,代表当前位置i和已经走了j步的情况下,有几种情况。那么我们可以知道dpij可以由dpi-1j-1和dpi+1j-1状态转移而来。

最后我们返回dpendPos+offsetk,也就是在终点并且已经走了k步的情况下的情况有多少种。

相关推荐
ZhengEnCi7 小时前
GPT-6 Astra 爆改 Qwen 权重真有那么神吗:权重空间编程 0.016% 参数的真相
算法·架构
罗西的思考7 小时前
【轻量化复刻大模型 / KIMI K3】KDA(Kimi Delta Attention):并行
人工智能·算法·机器学习
夜不会漫长9 小时前
C++:红黑树
数据结构·算法
文丑颜不良啊9 小时前
LeetCode1661~1680题目解析
java·leetcode
AI备案指南-满满10 小时前
算法备案审核不通过,一般是什么原因?
java·人工智能·算法·大模型备案·算法备案·大模型登记
Ramble_Naylor10 小时前
Rust深度解读:Send 与 Sync 的本质与线程安全边界
python·算法·rust
秋天的怀念_David10 小时前
算法一千零一夜 · 第二十三夜 电力民生写成的曲线
java·程序人生·算法
不一样的故事12610 小时前
NB/T 47013.8-2015 附录D 吸枪技术
人工智能·经验分享·算法
通问AI10 小时前
用 200 行 Python 给文档库做「上下文完整度」自检:四个可复算的检查项
算法
揽星河..11 小时前
【C语言】扫雷游戏
c语言·算法·游戏